/*
 * (c) Copyright 2012 EVRYTHNG Ltd London / Zurich
 * www.evrythng.com
 */
package com.evrythng.thng.resource.model.access;

/**
 * SocialNetwork access of an {@link Application}. Contains the appId, e.g.
 * facebook application id.
 * As defined on the social network side.
 * 
 **/
public class SocialNetwork {

	public SocialNetwork() {
		// nop
	}

	/**
	 * Create a SocialNetwork having the give appId set
	 * 
	 * @param appId
	 */
	public SocialNetwork(String appId) {
		this.appId = appId;
	}

	private String appId;

	/**
	 * 
	 * @return the appId
	 */
	public String getAppId() {
		return appId;
	}

	/**
	 * @param appId
	 *            the appId to set
	 */
	public void setAppId(String appId) {
		this.appId = appId;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((appId == null) ? 0 : appId.hashCode());
		return result;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		SocialNetwork other = (SocialNetwork) obj;
		if (appId == null) {
			if (other.appId != null)
				return false;
		} else if (!appId.equals(other.appId))
			return false;
		return true;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String toString() {
		return "[appId=" + appId + "]";
	}

}
